diff --git a/src/include/storage/proc.h b/src/include/storage/proc.h
index 205f484510..bc611fd8cc 100644
--- a/src/include/storage/proc.h
+++ b/src/include/storage/proc.h
@@ -23,24 +23,6 @@
 #include "storage/proclist_types.h"
 
 /*
- * Each backend advertises up to PGPROC_MAX_CACHED_SUBXIDS TransactionIds
- * for non-aborted subtransactions of its current top transaction.  These
- * have to be treated as running XIDs by other backends.
- *
- * We also keep track of whether the cache overflowed (ie, the transaction has
- * generated at least one subtransaction that didn't fit in the cache).
- * If none of the caches have overflowed, we can assume that an XID that's not
- * listed anywhere in the PGPROC array is not a running transaction.  Else we
- * have to look at pg_subtrans.
- */
-#define PGPROC_MAX_CACHED_SUBXIDS 64	/* XXX guessed-at value */
-
-struct XidCache
-{
-	TransactionId xids[PGPROC_MAX_CACHED_SUBXIDS];
-};
-
-/*
  * Flags for PGXACT->vacuumFlags
  *
  * Note: If you modify these flags, you need to modify PROCARRAY_XXX flags
@@ -77,6 +59,14 @@ struct XidCache
 #define INVALID_PGPROCNO		PG_INT32_MAX
 
 /*
+ * The number of subtransactions below which we consider to apply clog group
+ * update optimization.  Testing reveals that the number higher than this can
+ * hurt performance.
+ */
+#define THRESHOLD_SUBTRANS_CLOG_OPT	5
+
+
+/*
  * Each backend has a PGPROC struct in shared memory.  There is also a list of
  * currently-unused PGPROC structs that will be reallocated to new backends.
  *
@@ -156,8 +146,6 @@ struct PGPROC
 	 */
 	SHM_QUEUE	myProcLocks[NUM_LOCK_PARTITIONS];
 
-	struct XidCache subxids;	/* cache for subtransaction XIDs */
-
 	/* Support for group XID clearing. */
 	/* true, if member of ProcArray group waiting for XID clear */
 	bool		procArrayGroupMember;
@@ -176,12 +164,14 @@ struct PGPROC
 	bool		clogGroupMember;	/* true, if member of clog group */
 	pg_atomic_uint32 clogGroupNext; /* next clog group member */
 	TransactionId clogGroupMemberXid;	/* transaction id of clog group member */
-	XidStatus	clogGroupMemberXidStatus;	/* transaction status of clog
+	CLogXidStatus	clogGroupMemberXidStatus;	/* transaction status of clog
 											 * group member */
 	int			clogGroupMemberPage;	/* clog page corresponding to
 										 * transaction id of clog group member */
 	XLogRecPtr	clogGroupMemberLsn; /* WAL location of commit record for clog
 									 * group member */
+	TransactionId		clogGroupSubxids[THRESHOLD_SUBTRANS_CLOG_OPT];
+	int					clogGroupNSubxids;
 
 	/* Per-backend LWLock.  Protects fields below (but not group fields). */
 	LWLock		backendLock;
@@ -215,6 +205,9 @@ extern PGDLLIMPORT struct PGXACT *MyPgXact;
  * considerably on systems with many CPU cores, by reducing the number of
  * cache lines needing to be fetched.  Thus, think very carefully before adding
  * anything else here.
+ *
+ * XXX: GetSnapshotData no longer does that, so perhaps we should put these
+ * back to PGPROC for simplicity's sake.
  */
 typedef struct PGXACT
 {
@@ -224,15 +217,17 @@ typedef struct PGXACT
 
 	TransactionId xmin;			/* minimal running XID as it was when we were
 								 * starting our xact, excluding LAZY VACUUM:
-								 * vacuum must not remove tuples deleted by
 								 * xid >= xmin ! */
 
+	CommitSeqNo	snapshotcsn;	/* oldest snapshot in use in this backend:
+								 * vacuum must not remove tuples deleted by
+								 * xacts with commit seqno > snapshotcsn !
+								 * XXX: currently unused, vacuum uses just xmin, still.
+								 */
+
 	uint8		vacuumFlags;	/* vacuum-related flags, see above */
-	bool		overflowed;
 	bool		delayChkpt;		/* true if this proc delays checkpoint start;
 								 * previously called InCommit */
-
-	uint8		nxids;
 } PGXACT;
 
 /*
diff --git a/src/include/storage/procarray.h b/src/include/storage/procarray.h
index 174c537be4..1e54b5d92c 100644
--- a/src/include/storage/procarray.h
+++ b/src/include/storage/procarray.h
@@ -58,25 +58,18 @@
 extern Size ProcArrayShmemSize(void);
 extern void CreateSharedProcArray(void);
 extern void ProcArrayAdd(PGPROC *proc);
-extern void ProcArrayRemove(PGPROC *proc, TransactionId latestXid);
+extern void ProcArrayRemove(PGPROC *proc);
 
-extern void ProcArrayEndTransaction(PGPROC *proc, TransactionId latestXid);
+extern void ProcArrayEndTransaction(PGPROC *proc);
 extern void ProcArrayClearTransaction(PGPROC *proc);
+extern void ProcArrayResetXmin(PGPROC *proc);
 
-extern void ProcArrayInitRecovery(TransactionId initializedUptoXID);
+extern void ProcArrayInitRecovery(TransactionId oldestActiveXID, TransactionId initializedUptoXID);
 extern void ProcArrayApplyRecoveryInfo(RunningTransactions running);
 extern void ProcArrayApplyXidAssignment(TransactionId topxid,
 							int nsubxids, TransactionId *subxids);
 
 extern void RecordKnownAssignedTransactionIds(TransactionId xid);
-extern void ExpireTreeKnownAssignedTransactionIds(TransactionId xid,
-									  int nsubxids, TransactionId *subxids,
-									  TransactionId max_xid);
-extern void ExpireAllKnownAssignedTransactionIds(void);
-extern void ExpireOldKnownAssignedTransactionIds(TransactionId xid);
-
-extern int	GetMaxSnapshotXidCount(void);
-extern int	GetMaxSnapshotSubxidCount(void);
 
 extern Snapshot GetSnapshotData(Snapshot snapshot);
 
@@ -86,8 +79,9 @@ extern bool ProcArrayInstallRestoredXmin(TransactionId xmin, PGPROC *proc);
 
 extern RunningTransactions GetRunningTransactionData(void);
 
-extern bool TransactionIdIsInProgress(TransactionId xid);
 extern bool TransactionIdIsActive(TransactionId xid);
+extern TransactionId GetRecentGlobalXmin(void);
+extern TransactionId GetRecentGlobalDataXmin(void);
 extern TransactionId GetOldestXmin(Relation rel, int flags);
 extern TransactionId GetOldestActiveTransactionId(void);
 extern TransactionId GetOldestSafeDecodingTransactionId(bool catalogOnly);
@@ -100,9 +94,8 @@ extern PGPROC *BackendPidGetProcWithLock(int pid);
 extern int	BackendXidGetPid(TransactionId xid);
 extern bool IsBackendPid(int pid);
 
-extern VirtualTransactionId *GetCurrentVirtualXIDs(TransactionId limitXmin,
-					  bool excludeXmin0, bool allDbs, int excludeVacuum,
-					  int *nvxids);
+extern VirtualTransactionId *GetCurrentVirtualXIDs(TransactionId limitXmin, bool excludeXmin0,
+					  bool allDbs, int excludeVacuum, int *nvxids);
 extern VirtualTransactionId *GetConflictingVirtualXIDs(TransactionId limitXmin, Oid dbOid);
 extern pid_t CancelVirtualTransaction(VirtualTransactionId vxid, ProcSignalReason sigmode);
 
@@ -114,10 +107,6 @@ extern int	CountUserBackends(Oid roleid);
 extern bool CountOtherDBBackends(Oid databaseId,
 					 int *nbackends, int *nprepared);
 
-extern void XidCacheRemoveRunningXids(TransactionId xid,
-						  int nxids, const TransactionId *xids,
-						  TransactionId latestXid);
-
 extern void ProcArraySetReplicationSlotXmin(TransactionId xmin,
 								TransactionId catalog_xmin, bool already_locked);
 
diff --git a/src/include/storage/standby.h b/src/include/storage/standby.h
index f5404b4c1f..80d0917615 100644
--- a/src/include/storage/standby.h
+++ b/src/include/storage/standby.h
@@ -50,10 +50,7 @@ extern void StandbyAcquireAccessExclusiveLock(TransactionId xid, Oid dbOid, Oid
 extern void StandbyReleaseLockTree(TransactionId xid,
 					   int nsubxids, TransactionId *subxids);
 extern void StandbyReleaseAllLocks(void);
-extern void StandbyReleaseOldLocks(int nxids, TransactionId *xids);
-
-#define MinSizeOfXactRunningXacts offsetof(xl_running_xacts, xids)
-
+extern void StandbyReleaseOldLocks(TransactionId oldestRunningXid);
 
 /*
  * Declarations for GetRunningTransactionData(). Similar to Snapshots, but
@@ -69,14 +66,8 @@ extern void StandbyReleaseOldLocks(int nxids, TransactionId *xids);
 
 typedef struct RunningTransactionsData
 {
-	int			xcnt;			/* # of xact ids in xids[] */
-	int			subxcnt;		/* # of subxact ids in xids[] */
-	bool		subxid_overflow;	/* snapshot overflowed, subxids missing */
 	TransactionId nextXid;		/* copy of ShmemVariableCache->nextXid */
-	TransactionId oldestRunningXid; /* *not* oldestXmin */
-	TransactionId latestCompletedXid;	/* so we can set xmax */
-
-	TransactionId *xids;		/* array of (sub)xids still running */
+	TransactionId oldestRunningXid;		/* *not* oldestXmin */
 } RunningTransactionsData;
 
 typedef RunningTransactionsData *RunningTransactions;
diff --git a/src/include/storage/standbydefs.h b/src/include/storage/standbydefs.h
index a0af6788e9..2bc167e5cc 100644
--- a/src/include/storage/standbydefs.h
+++ b/src/include/storage/standbydefs.h
@@ -46,16 +46,13 @@ typedef struct xl_standby_locks
  */
 typedef struct xl_running_xacts
 {
-	int			xcnt;			/* # of xact ids in xids[] */
-	int			subxcnt;		/* # of subxact ids in xids[] */
-	bool		subxid_overflow;	/* snapshot overflowed, subxids missing */
 	TransactionId nextXid;		/* copy of ShmemVariableCache->nextXid */
 	TransactionId oldestRunningXid; /* *not* oldestXmin */
 	TransactionId latestCompletedXid;	/* so we can set xmax */
-
-	TransactionId xids[FLEXIBLE_ARRAY_MEMBER];
 } xl_running_xacts;
 
+#define SizeOfXactRunningXacts (offsetof(xl_running_xacts, latestCompletedXid) + sizeof(TransactionId))
+
 /*
  * Invalidations for standby, currently only when transactions without an
  * assigned xid commit.
diff --git a/src/include/utils/snapmgr.h b/src/include/utils/snapmgr.h
index fc64153780..bbef99b875 100644
--- a/src/include/utils/snapmgr.h
+++ b/src/include/utils/snapmgr.h
@@ -57,9 +57,6 @@ extern TimestampTz GetOldSnapshotThresholdTimestamp(void);
 extern bool FirstSnapshotSet;
 
 extern TransactionId TransactionXmin;
-extern TransactionId RecentXmin;
-extern PGDLLIMPORT TransactionId RecentGlobalXmin;
-extern TransactionId RecentGlobalDataXmin;
 
 extern Snapshot GetTransactionSnapshot(void);
 extern Snapshot GetLatestSnapshot(void);
diff --git a/src/include/utils/snapshot.h b/src/include/utils/snapshot.h
index bf519778df..759cbd4fc8 100644
--- a/src/include/utils/snapshot.h
+++ b/src/include/utils/snapshot.h
@@ -60,37 +60,18 @@ typedef struct SnapshotData
 	 * specially by HeapTupleSatisfiesDirty, and xmin is used specially by
 	 * HeapTupleSatisfiesNonVacuumable.)
 	 *
-	 * An MVCC snapshot can never see the effects of XIDs >= xmax. It can see
-	 * the effects of all older XIDs except those listed in the snapshot. xmin
-	 * is stored as an optimization to avoid needing to search the XID arrays
-	 * for most tuples.
+	 * An MVCC snapshot can see the effects of those XIDs that committed
+	 * after snapshotlsn. xmin and xmax are stored as an optimization, to
+	 * avoid checking the commit LSN for most tuples.
 	 */
 	TransactionId xmin;			/* all XID < xmin are visible to me */
 	TransactionId xmax;			/* all XID >= xmax are invisible to me */
 
 	/*
-	 * For normal MVCC snapshot this contains the all xact IDs that are in
-	 * progress, unless the snapshot was taken during recovery in which case
-	 * it's empty. For historic MVCC snapshots, the meaning is inverted, i.e.
-	 * it contains *committed* transactions between xmin and xmax.
-	 *
-	 * note: all ids in xip[] satisfy xmin <= xip[i] < xmax
-	 */
-	TransactionId *xip;
-	uint32		xcnt;			/* # of xact ids in xip[] */
-
-	/*
-	 * For non-historic MVCC snapshots, this contains subxact IDs that are in
-	 * progress (and other transactions that are in progress if taken during
-	 * recovery). For historic snapshot it contains *all* xids assigned to the
-	 * replayed transaction, including the toplevel xid.
-	 *
-	 * note: all ids in subxip[] are >= xmin, but we don't bother filtering
-	 * out any that are >= xmax
+	 * This snapshot can see the effects of all transactions with CSN <=
+	 * snapshotcsn.
 	 */
-	TransactionId *subxip;
-	int32		subxcnt;		/* # of xact ids in subxip[] */
-	bool		suboverflowed;	/* has the subxip array overflowed? */
+	CommitSeqNo	snapshotcsn;
 
 	bool		takenDuringRecovery;	/* recovery-shaped snapshot? */
 	bool		copied;			/* false if it's a static snapshot */
@@ -104,6 +85,14 @@ typedef struct SnapshotData
 	uint32		speculativeToken;
 
 	/*
+	 * this_xip contains *all* xids assigned to the replayed transaction,
+	 * including the toplevel xid. Used only in a historic MVCC snapshot,
+	 * used in logical decoding.
+	 */
+	TransactionId *this_xip;
+	uint32		this_xcnt;			/* # of xact ids in this_xip[] */
+
+	/*
 	 * Book-keeping information, used by the snapshot manager
 	 */
 	uint32		active_count;	/* refcount on ActiveSnapshot stack */
diff --git a/src/test/modules/mvcctorture/Makefile b/src/test/modules/mvcctorture/Makefile
new file mode 100644
index 0000000000..cc4ebc838a
--- /dev/null
+++ b/src/test/modules/mvcctorture/Makefile
@@ -0,0 +1,18 @@
+# src/test/modules/mvcctorture/Makefile
+
+MODULE_big	= mvcctorture
+OBJS		= mvcctorture.o
+
+EXTENSION = mvcctorture
+DATA = mvcctorture--1.0.sql
+
+ifdef USE_PGXS
+PG_CONFIG = pg_config
+PGXS := $(shell $(PG_CONFIG) --pgxs)
+include $(PGXS)
+else
+subdir = src/test/modules/mvcctorture
+top_builddir = ../../../..
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+endif
diff --git a/src/test/modules/mvcctorture/README b/src/test/modules/mvcctorture/README
new file mode 100644
index 0000000000..915b00129a
--- /dev/null
+++ b/src/test/modules/mvcctorture/README
@@ -0,0 +1,25 @@
+A litte helper module for testing MVCC performance.
+
+The populate_mvcc_test_table function can be used to create a test table,
+with given number of rows. Each row in the table is stamped with a different
+xmin, and XMIN_COMMITTED hint bit can be set or not. Furthermore, the
+xmins values are shuffled, to defeat caching in transam.c and clog.c as badly
+as possible.
+
+The test table is always called "mvcc_test_table". You'll have to drop it
+yourself between tests.
+
+For example:
+
+-- Create a test table with 10 million rows, without setting hint bits
+select populate_mvcc_test_table(10000000, false);
+
+-- See how long it takes to scan it
+\timing
+select count(*) from mvcc_test_table;
+
+
+
+If you do the above, but have another psql session open, in a transaction
+that's done some updates, i.e. is holding backthe xmin horizon, you will
+see the worst-case performance of the CSN patch.
diff --git a/src/test/modules/mvcctorture/mvcctorture--1.0.sql b/src/test/modules/mvcctorture/mvcctorture--1.0.sql
new file mode 100644
index 0000000000..652a6a3f39
--- /dev/null
+++ b/src/test/modules/mvcctorture/mvcctorture--1.0.sql
@@ -0,0 +1,9 @@
+/* src/test/modules/mvcctorture/mvcctorture--1.0.sql */
+
+-- complain if script is sourced in psql, rather than via CREATE EXTENSION
+\echo Use "CREATE EXTENSION mvcctorture" to load this file. \quit
+
+CREATE FUNCTION populate_mvcc_test_table(int4, bool)
+RETURNS void
+AS 'MODULE_PATHNAME', 'populate_mvcc_test_table'
+LANGUAGE C STRICT;
diff --git a/src/test/modules/mvcctorture/mvcctorture.c b/src/test/modules/mvcctorture/mvcctorture.c
new file mode 100644
index 0000000000..a89a2e6e96
--- /dev/null
+++ b/src/test/modules/mvcctorture/mvcctorture.c
@@ -0,0 +1,129 @@
+/*-------------------------------------------------------------------------
+ *
+ * mvctorture.c
+ *
+ * Copyright (c) 2012, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/test/modules/mvcctorture.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/heapam.h"
+#include "access/hio.h"
+#include "access/htup_details.h"
+#include "access/transam.h"
+#include "access/xact.h"
+#include "access/visibilitymap.h"
+#include "catalog/pg_am.h"
+#include "executor/spi.h"
+#include "funcapi.h"
+#include "nodes/makefuncs.h"
+#include "storage/bufmgr.h"
+#include "utils/rel.h"
+
+PG_MODULE_MAGIC;
+
+PG_FUNCTION_INFO_V1(populate_mvcc_test_table);
+
+Datum
+populate_mvcc_test_table(PG_FUNCTION_ARGS)
+{
+	uint32		nrows = PG_GETARG_UINT32(0);
+	bool		set_xmin_committed = PG_GETARG_BOOL(1);
+	RangeVar   *rv;
+	Relation	rel;
+	Datum		values[1];
+	bool		isnull[1];
+	HeapTuple	tup;
+	TransactionId *xids;
+	int			ret;
+	int			i;
+	Buffer		buffer;
+	Buffer		vmbuffer = InvalidBuffer;
+
+	/* Connect to SPI manager */
+	if ((ret = SPI_connect()) < 0)
+		/* internal error */
+		elog(ERROR, "populate_mvcc_test_table: SPI_connect returned %d", ret);
+
+	SPI_execute("CREATE TABLE mvcc_test_table(i int4)", false, 0);
+
+	SPI_finish();
+
+	/* Generate a different XID for each tuple */
+	xids = (TransactionId *) palloc0(nrows * sizeof(TransactionId));
+	for (i = 0; i < nrows; i++)
+	{
+		BeginInternalSubTransaction(NULL);
+		xids[i] = GetCurrentTransactionId();
+		ReleaseCurrentSubTransaction();
+	}
+
+	rv = makeRangeVar(NULL, "mvcc_test_table", -1);
+
+	rel = heap_openrv(rv, RowExclusiveLock);
+
+	/* shuffle */
+	for (i = 0; i < nrows - 1; i++)
+	{
+		int x = i + (random() % (nrows - i));
+		TransactionId tmp;
+
+		tmp = xids[i];
+		xids[i] = xids[x];
+		xids[x] = tmp;
+	}
+
+	for (i = 0; i < nrows; i++)
+	{
+		values[0] = Int32GetDatum(i);
+		isnull[0] = false;
+
+		tup = heap_form_tuple(RelationGetDescr(rel), values, isnull);
+
+		/* Fill the header fields, like heap_prepare_insert does */
+		tup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
+		tup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
+		tup->t_data->t_infomask |= HEAP_XMAX_INVALID;
+		if (set_xmin_committed)
+			tup->t_data->t_infomask |= HEAP_XMIN_COMMITTED;
+		HeapTupleHeaderSetXmin(tup->t_data, xids[i]);
+		HeapTupleHeaderSetCmin(tup->t_data, 1);
+		HeapTupleHeaderSetXmax(tup->t_data, 0);		/* for cleanliness */
+		tup->t_tableOid = RelationGetRelid(rel);
+
+		heap_freetuple(tup);
+
+		/*
+		 * Find buffer to insert this tuple into.  If the page is all visible,
+		 * this will also pin the requisite visibility map page.
+		 */
+		buffer = RelationGetBufferForTuple(rel, tup->t_len,
+										   InvalidBuffer,
+										   0, NULL,
+										   &vmbuffer, NULL);
+		RelationPutHeapTuple(rel, buffer, tup, false);
+
+		if (PageIsAllVisible(BufferGetPage(buffer)))
+		{
+			PageClearAllVisible(BufferGetPage(buffer));
+			visibilitymap_clear(rel,
+								ItemPointerGetBlockNumber(&(tup->t_self)),
+								vmbuffer, VISIBILITYMAP_VALID_BITS);
+		}
+
+		MarkBufferDirty(buffer);
+		UnlockReleaseBuffer(buffer);
+	}
+
+	if (vmbuffer != InvalidBuffer)
+		ReleaseBuffer(vmbuffer);
+
+	heap_close(rel, NoLock);
+
+	PG_RETURN_VOID();
+}
diff --git a/src/test/modules/mvcctorture/mvcctorture.control b/src/test/modules/mvcctorture/mvcctorture.control
new file mode 100644
index 0000000000..1b5feb95a7
--- /dev/null
+++ b/src/test/modules/mvcctorture/mvcctorture.control
@@ -0,0 +1,5 @@
+# mvcctorture extension
+comment = 'populate a table with a mix of different XIDs'
+default_version = '1.0'
+module_pathname = '$libdir/mvcctorture'
+relocatable = true
diff --git a/src/test/regress/sql/txid.sql b/src/test/regress/sql/txid.sql
index bd6decf0ef..6775e04e33 100644
--- a/src/test/regress/sql/txid.sql
+++ b/src/test/regress/sql/txid.sql
@@ -1,32 +1,22 @@
 -- txid_snapshot data type and related functions
 
 -- i/o
-select '12:13:'::txid_snapshot;
-select '12:18:14,16'::txid_snapshot;
-select '12:16:14,14'::txid_snapshot;
+select '12:0/ABCDABCD'::txid_snapshot;
 
 -- errors
-select '31:12:'::txid_snapshot;
-select '0:1:'::txid_snapshot;
-select '12:13:0'::txid_snapshot;
-select '12:16:14,13'::txid_snapshot;
+select '0:0/ABCDABCD'::txid_snapshot;
 
 create temp table snapshot_test (
 	nr	integer,
 	snap	txid_snapshot
 );
 
-insert into snapshot_test values (1, '12:13:');
-insert into snapshot_test values (2, '12:20:13,15,18');
-insert into snapshot_test values (3, '100001:100009:100005,100007,100008');
-insert into snapshot_test values (4, '100:150:101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131');
+insert into snapshot_test values (1, '12:0/ABCDABCD');
 select snap from snapshot_test order by nr;
 
-select  txid_snapshot_xmin(snap),
-	txid_snapshot_xmax(snap),
-	txid_snapshot_xip(snap)
+select  txid_snapshot_xmax(snap)
 from snapshot_test order by nr;
-
+/*
 select id, txid_visible_in_snapshot(id, snap)
 from snapshot_test, generate_series(11, 21) id
 where nr = 2;
@@ -35,7 +25,7 @@ where nr = 2;
 select id, txid_visible_in_snapshot(id, snap)
 from snapshot_test, generate_series(90, 160) id
 where nr = 4;
-
+*/
 -- test current values also
 select txid_current() >= txid_snapshot_xmin(txid_current_snapshot());
 
@@ -43,6 +33,7 @@ select txid_current() >= txid_snapshot_xmin(txid_current_snapshot());
 
 select txid_visible_in_snapshot(txid_current(), txid_current_snapshot());
 
+/*
 -- test 64bitness
 
 select txid_snapshot '1000100010001000:1000100010001100:1000100010001012,1000100010001013';
@@ -92,8 +83,9 @@ BEGIN
   RAISE EXCEPTION 'didn''t ERROR at xid in the future as expected';
 EXCEPTION
   WHEN invalid_parameter_value THEN
-    RAISE NOTICE 'Got expected error for xid in the future';
+	RAISE NOTICE 'Got expected error for xid in the future';
 END;
 $$;
 SELECT test_future_xid_status(:inprogress + 10000);
 ROLLBACK;
+*/
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 17ba2bde5c..1276ab24e7 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -34,6 +34,9 @@ AfterTriggerEventList
 AfterTriggerShared
 AfterTriggerSharedData
 AfterTriggersData
+AfterTriggersQueryData
+AfterTriggersTableData
+AfterTriggersTransData
 Agg
 AggClauseCosts
 AggInfo
@@ -125,7 +128,6 @@ ArrayMetaState
 ArrayParseState
 ArrayRef
 ArrayRefState
-ArrayRemapInfo
 ArrayType
 AsyncQueueControl
 AsyncQueueEntry
@@ -143,7 +145,6 @@ AutoVacOpts
 AutoVacuumShmemStruct
 AutoVacuumWorkItem
 AutoVacuumWorkItemType
-AutovacWorkItems
 AuxProcType
 BF_ctx
 BF_key
@@ -633,6 +634,7 @@ FileFdwPlanState
 FileName
 FileNameMap
 FindSplitData
+FixedParallelExecutorState
 FixedParallelState
 FixedParamState
 FlagMode
@@ -1019,13 +1021,13 @@ InsertStmt
 Instrumentation
 Int128AggState
 Int8TransTypeData
+IntRBTreeNode
 InternalDefaultACL
 InternalGrant
 Interval
 IntoClause
 InvalidationChunk
 InvalidationListHeader
-InvertedWalkNextStep
 IpcMemoryId
 IpcMemoryKey
 IpcSemaphoreId
@@ -1567,6 +1569,7 @@ PartitionListValue
 PartitionRangeBound
 PartitionRangeDatum
 PartitionRangeDatumKind
+PartitionScheme
 PartitionSpec
 PartitionedChildRelInfo
 PasswordType
@@ -1777,7 +1780,6 @@ RangeBox
 RangeFunction
 RangeIOData
 RangeQueryClause
-RangeRemapInfo
 RangeSubselect
 RangeTableFunc
 RangeTableFuncCol
@@ -1790,6 +1792,7 @@ RangeVar
 RangeVarGetRelidCallback
 RawColumnDefault
 RawStmt
+ReInitializeDSMForeignScan_function
 ReScanForeignScan_function
 ReadBufPtrType
 ReadBufferMode
@@ -1801,8 +1804,6 @@ RecheckForeignScan_function
 RecordCacheEntry
 RecordCompareData
 RecordIOData
-RecordRemapInfo
-RecordTypmodMap
 RecoveryTargetAction
 RecoveryTargetType
 RectBox
@@ -2016,6 +2017,11 @@ SharedInvalRelmapMsg
 SharedInvalSmgrMsg
 SharedInvalSnapshotMsg
 SharedInvalidationMessage
+SharedRecordTableEntry
+SharedRecordTableKey
+SharedRecordTypmodRegistry
+SharedSortInfo
+SharedTypmodTableEntry
 ShellTypeInfo
 ShippableCacheEntry
 ShippableCacheKey
@@ -2289,9 +2295,10 @@ TupleHashEntryData
 TupleHashIterator
 TupleHashTable
 TupleQueueReader
-TupleRemapClass
-TupleRemapInfo
 TupleTableSlot
+TuplesortInstrumentation
+TuplesortMethod
+TuplesortSpaceType
 Tuplesortstate
 Tuplestorestate
 TwoPhaseCallback
@@ -2321,7 +2328,6 @@ UChar
 UCharIterator
 UCollator
 UConverter
-UEnumeration
 UErrorCode
 UINT
 ULARGE_INTEGER
@@ -2604,7 +2610,9 @@ dsa_pointer
 dsa_segment_header
 dsa_segment_index
 dsa_segment_map
+dshash_compare_function
 dshash_hash
+dshash_hash_function
 dshash_parameters
 dshash_partition
 dshash_table
